const app = getApp()
import WxValidate from '../../utils/wxValidate'
import { gender } from '../../utils/dict';
Page({

    /**
     * 页面的初始数据
     */
    data: {
        frameStyle: { useTop: true, name: '个人信息', leftArrow: true, useBar: false },
        icon: '/image/icon.jpg',
        form: { id: "1", icon: [], img_url: "/image/icon.jpg", name: "测试", gender: '男', phone: '13174420325', email: '' },
        // 头像
        icon: [],
        // 性别
        genderList: gender,
    },
    initValidate() {
        const rules = { name: { required: true }, phone: { required: true, tel: true }, gender: { required: true }, email: { required: true } }
        // 验证字段的提示信息，若不传则调用默认的信息
        const messages = { name: { required: '请输入用户名', }, phone: { required: '请输入手机号', }, gender: { required: '请选择性别', }, email: { required: '请输入邮箱' } };
        this.WxValidate = new WxValidate(rules, messages)
    },
    // 返回
    back: function () {
        wx.navigateBack({ delta: 1 })
    },
    // 上傳圖片
    imgUpload: function (e) {
        const that = this;
        let data = that.data.icon;
        data.push(e.detail)
        that.setData({ icon: data })
    },
    // 删除图片
    imgDel: function (e) {
        const that = this;
        let list = that.data.icon;
        let arr = list.filter((i, index) => index != e.detail.index)
        that.setData({ icon: arr })
    },
    // 选择性别
    genderChange: function (e) {
        const that = this;
        let index = e.detail.value;
        let value = that.data.genderList[index];
        that.setData({ 'form.gender': value.value });
    },
    // 提交登录
    onSubmit: async function (e) {
        const that = this;
        const params = e.detail.value;
        const data = that.data.form;
        if (!this.WxValidate.checkForm(params)) {
            const error = this.WxValidate.errorList[0];
            wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            return false
        } else {
            let arr;
            if (data._id) {
                if (!params.icon) params.icon = that.data.icon;
                arr = await app.$post(`/newCourt/api/user/${data._id}`, params);
                if (arr.errcode == '0') { wx.showToast({ title: `维护信息完成`, icon: 'success', duration: 2000 }); that.back(); }
                else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
            } else {
                arr = await app.$get(`/newCourt/api/user`, { phone: params.phone });
                if (arr.errcode == '0' && arr.total > 0) wx.showToast({ title: `该账号已有用户使用`, icon: 'error', duration: 2000 })
                else {
                    params.icon = that.data.icon;
                    arr = await app.$post(`/newCourt/api/user`, params);
                    if (arr.errcode == '0') { wx.showToast({ title: `添加信息完成`, icon: 'success', duration: 2000 }); that.back(); }
                    else wx.showToast({ title: `${error.msg}`, icon: 'error', duration: 2000 })
                }
            }
        }
    },
    /**
     * 生命周期函数--监听页面加载
     */
    onLoad: function (options) {
        const that = this;
        //验证规则函数
        that.initValidate();
        // 监听用户是否登录
        that.watchLogin();
    },
    // 监听用户是否登录
    watchLogin: async function () {
        const that = this;
        wx.getStorage({
            key: 'user',
            success: async res => {
                const arr = await app.$get(`/newCourt/api/user/${res.data.openid}`);
                if (arr.errcode == '0') {
                    if (arr.data.icon) that.setData({ icon: arr.data.icon });
                    that.setData({ form: arr.data });
                }
            },
            fail: res => {
                wx.redirectTo({ url: '/pages/index/index', })
            }
        })
    },
    /**
     * 生命周期函数--监听页面初次渲染完成
     */
    onReady: function () {

    },

    /**
     * 生命周期函数--监听页面显示
     */
    onShow: function () {

    },

    /**
     * 生命周期函数--监听页面隐藏
     */
    onHide: function () {

    },

    /**
     * 生命周期函数--监听页面卸载
     */
    onUnload: function () {

    },

    /**
     * 页面相关事件处理函数--监听用户下拉动作
     */
    onPullDownRefresh: function () {

    },

    /**
     * 页面上拉触底事件的处理函数
     */
    onReachBottom: function () {

    },

    /**
     * 用户点击右上角分享
     */
    onShareAppMessage: function () {

    }
})